Home | History | Annotate | Download | only in util-src
      1 #!/bin/bash
      2 #
      3 # Copyright (C) 2018 The Android Open Source Project
      4 #
      5 # Licensed under the Apache License, Version 2.0 (the "License");
      6 # you may not use this file except in compliance with the License.
      7 # You may obtain a copy of the License at
      8 #
      9 #     http://www.apache.org/licenses/LICENSE-2.0
     10 #
     11 # Unless required by applicable law or agreed to in writing, software
     12 # distributed under the License is distributed on an "AS IS" BASIS,
     13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     14 # See the License for the specific language governing permissions and
     15 # limitations under the License.
     16 
     17 function fail() {
     18   echo Build failed: $1 1>&2
     19   exit 1
     20 }
     21 
     22 D8=${ANDROID_HOST_OUT}/bin/d8
     23 if [[ ! -x "${D8}" ]]; then
     24   fail "Must have a runnable d8 binary!"
     25 fi
     26 
     27 if [[ -z "${ANDROID_BUILD_TOP}" ]]; then
     28   fail "ANDROID_BUILD_TOP is not defined. Try running 'lunch' first."
     29 fi
     30 
     31 SCRIPT_PATH=$( cd $(dirname $0) ; pwd -P )
     32 ASM_CLASSPATH="${ANDROID_BUILD_TOP}/prebuilts/misc/common/asm/asm-6.0.jar"
     33 SRC_PATH="${SCRIPT_PATH}/src"
     34 BUILD_PATH="${1:-${SCRIPT_PATH}/classes}"
     35 
     36 if [[ ! -d "${BUILD_PATH}" ]]; then
     37     mkdir "$BUILD_PATH" || exit 1
     38 fi
     39 
     40 # Build the initial class files.
     41 (cd "${SRC_PATH}" && javac -cp "${ASM_CLASSPATH}" -d "${BUILD_PATH}" Main.java art/*.java art/constmethodhandle/*.java) || fail "javac error"
     42 # Modify the class files using ASM
     43 (cd "${SCRIPT_PATH}" && java -cp "${ASM_CLASSPATH}:${BUILD_PATH}" art.constmethodhandle.TestGenerator "${BUILD_PATH}" "$D8") || fail "generator failure"
     44 # Remove the modification classes. We don't need nor want them for the actual test.
     45 (cd ${BUILD_PATH} && find . -name "TestGenerator*.class" | xargs rm) || fail "Cleanup failure"
     46